<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- 
IGAC proyecto SNC
@author 			christian.rodriguez
@cu 				CU-SA-AC-016 Asignar Permisos para Consultar Avalúos Reservados

-->

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:fn="http://java.sun.com/jsp/jstl/functions"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                xmlns:predio="http://java.sun.com/jsf/composite/predio"
                xmlns:avaluos="http://java.sun.com/jsf/composite/avaluos"
                template="../../templates/generalCU.xhtml">

    <ui:define name="title">
        .::Sistema Nacional Catastral::. .::Asignar permisos para consultar avalúos reservados::.
    </ui:define>

    <ui:define name="content" >

        <p:ajaxStatus onstart="statusDialog.show();"
                      onsuccess="statusDialog.hide();" onerror="statusDialog.hide();" />
        <p:focus />

        <p:spacer height="5" width="0" />

        <h:form id="asignarPermisosConsultaAvaluosReservadosForm" >

            <h:panelGrid id="busquedaAvaluosReservadosPG" width="100%">

                <p:fieldset >

                    <legend>
                        <h:outputText value="Criterios de búsqueda"
                                      styleClass="legendTitle" />
                    </legend>


                    <h:panelGrid columns="4" cellspacing="7" width="100%">

                        <h:outputLabel value="Departamento:" styleClass="outputLabelStyle" />
                        <h:selectOneMenu
                            value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.departamento}">
                            <f:selectItems
                                value="#{asignarPermisosConsultaAvaluosReservados.listaDepartamentos}" />
                            <p:ajax process="@this"
                                    listener="#{asignarPermisosConsultaAvaluosReservados.cargarListaMunicipios}"
                                    update=":asignarPermisosConsultaAvaluosReservadosForm:municipio"
                                    onstart="statusDialog2.show();"
                                    oncomplete="statusDialog2.hide();" />
                        </h:selectOneMenu>

                        <h:outputLabel value="Municipio:" styleClass="outputLabelStyle" />
                        <h:selectOneMenu id="municipio"
                                         value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.municipio}">
                            <f:selectItems
                                value="#{asignarPermisosConsultaAvaluosReservados.listaMunicipios}" />
                            <p:ajax process="@this" onstart="statusDialog2.show();"
                                    oncomplete="statusDialog2.hide();" />
                        </h:selectOneMenu>

                        <h:outputLabel value="Tipo avalúo:" styleClass="outputLabelStyle" />
                        <h:selectOneMenu 
                            value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.tipoAvaluo}">
                            <f:selectItem itemLabel="Seleccionar.." />
                            <f:selectItems value="#{general.avaluoTipoAvaluoV}" />
                        </h:selectOneMenu>


                        <h:outputLabel value="Radicación:" styleClass="outputLabelStyle" />
                        <h:inputText
                            value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.numeroRadicacionDefinitivo}" />

                        <h:outputLabel value="Sec. Radicado:"
                                       styleClass="outputLabelStyle" />
                        <h:inputText
                            value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.numeroSecRadicado}" />

                        <h:outputLabel value="Año aprobación avalúo:"
                                       styleClass="outputLabelStyle" />
                        <h:selectOneMenu label="Vigencia"
                                         value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.anioAprobacion}">
                            <f:selectItems value="#{general.rangoAniosDescDesdeActual}" />
                        </h:selectOneMenu>

                        <h:outputLabel value="Avaluador: " styleClass="outputLabelStyle" />
                        <h:selectOneMenu
                            value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.idProfesional}">
                            <f:selectItems
                                value="#{asignarPermisosConsultaAvaluosReservados.listaAvaluadores}" />
                        </h:selectOneMenu>

                        <h:outputLabel value="Tipo empresa" styleClass="outputLabelStyle" />
                        <h:selectOneRadio label="Tipo empresa"
                                          value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.tipoEmpresa}">
                            <f:selectItems value="#{general.personaTipoPersonaV}" />
                            <p:ajax
                                update=":asignarPermisosConsultaAvaluosReservadosForm:busquedaAvaluosReservadosPG"
                                listener="#{asignarPermisosConsultaAvaluosReservados.onChangeTipoPersona}" />
                        </h:selectOneRadio>

                        <h:outputLabel value="Razón social:" styleClass="outputLabelStyle"
                                       rendered="#{!asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />
                        <h:inputText
                            value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.nombreRazonSocial}"
                            rendered="#{!asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />

                        <h:outputLabel value="Sigla:" styleClass="outputLabelStyle"
                                       rendered="#{!asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />
                        <h:inputText
                            value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.sigla}"
                            rendered="#{!asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />

                        <h:outputLabel value="Primer nombre:"
                                       styleClass="outputLabelStyle"
                                       rendered="#{asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />
                        <h:inputText
                            value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.primerNombre}"
                            rendered="#{asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />

                        <h:outputLabel value="Segundo nombre:"
                                       styleClass="outputLabelStyle"
                                       rendered="#{asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />
                        <h:inputText
                            value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.segundoNombre}"
                            rendered="#{asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />

                        <h:outputLabel value="Primer apellido"
                                       styleClass="outputLabelStyle"
                                       rendered="#{asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />
                        <h:inputText
                            value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.primerApellido}"
                            rendered="#{asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />

                        <h:outputLabel value="Segundo apellido:"
                                       styleClass="outputLabelStyle"
                                       rendered="#{asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />
                        <h:inputText
                            value="#{asignarPermisosConsultaAvaluosReservados.filtroAvaluos.segundoApellido}"
                            rendered="#{asignarPermisosConsultaAvaluosReservados.banderaEsPersonaNatural}" />

                    </h:panelGrid>

                    <h:panelGrid columns="1" cellspacing="7">

                        <p:commandButton value="Buscar" icon="ui-icon ui-icon-search"
                                         action="#{asignarPermisosConsultaAvaluosReservados.buscar}"
                                         update=":asignarPermisosConsultaAvaluosReservadosForm:avaluosReservadosDT"
                                         onstart="statusDialog2.show();" onsuccess="statusDialog2.hide();" />

                    </h:panelGrid>
                </p:fieldset>

            </h:panelGrid>

            <p:fieldset id="avaluosReservadosFS">
                <legend>
                    <h:outputText value="Resultados de la consulta"
                                  styleClass="legendTitle" />
                </legend>

                <h:panelGrid columns="1" cellspacing="7" width="100%">

                    <p:messages id="msgsAPCAR" showDetail="false" globalOnly="false" />

                    <p:dataTable id="avaluosReservadosDT"
                                 value="#{asignarPermisosConsultaAvaluosReservados.avaluosReservados}"
                                 var="avaluo" rowKey="#{avaluo.id}" paginator="true" rows="10"
                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport}
                                 {NextPageLink} {LastPageLink}"
                                 rowsPerPageTemplate="10,20,30" paginatorPosition="bottom"
                                 emptyMessage="No se encontraron avalúos revisados">

                        <f:facet name="header">
                            <h:outputText value="Avalúos reservados"
                                          styleClass="outpuTextStyle" />
                        </f:facet>

                        <p:column headerText="Opciones">
                            <p:commandButton title="Información de los predios del avalúo"
                                             icon="ui-icon-home"
                                             action="#{consultaInformacionPredial.cargarInformacionPredial}"
                                             update=":prediosAvaluoForm" onstart="statusDialog2.show();"
                                             oncomplete="statusDialog2.hide();
                                             handleCompleteSIC(xhr, status, args, infoPredialWV, true);">
                                <f:setPropertyActionListener value="#{avaluo}"
                                                             target="#{consultaInformacionPredial.avaluoSeleccionado}" />
                            </p:commandButton>
                            <p:commandButton title="Asignar permisos" icon="ui-icon-key"
                                             action="#{asignarPermisosConsultaAvaluosReservados.cargarAsignarDesasignarPermisos}"
                                             update=":prediosAvaluoForm,
                                             :asignarPermisosConsultaAvaluosReservadosDlgForm"
                                             onstart="statusDialog2.show();"
                                             oncomplete="statusDialog2.hide();
                                             handleCompleteSIC(xhr, status, args, asignarPermisosWV, true);">
                                <f:setPropertyActionListener value="#{avaluo}"
                                                             target="#{asignarPermisosConsultaAvaluosReservados.avaluoSeleccionado}" />
                            </p:commandButton>
                        </p:column>

                        <p:column headerText="Sec_Radicado" sortBy="#{avaluo.secRadicado}">
                            <p:commandLink styleClass="commandLinkStyle"
                                           action="#{consultaInformacionSolicitud.consultarSecRadicado}"
                                           update=":isCC:infoSolicitudTV" onstart="statusDialog2.show();"
                                           oncomplete="infoSolicitudCCWV.show(); statusDialog2.hide()"
                                           value="#{avaluo.secRadicado}">
                                <f:setPropertyActionListener value="#{avaluo.secRadicado}"
                                                             target="#{consultaInformacionSolicitud.numeroSecRadicado}" />
                            </p:commandLink>
                        </p:column>

                        <p:column headerText="Departamento"
                                  sortBy="#{avaluo.avaluoPredios[0].departamento.nombre}">
                            <p:commandLink
                                value="#{avaluo.avaluoPredios[0].departamento.nombre}"
                                rendered="#{avaluo.tienePrediosEnDiferentesDeptos}"
                                styleClass="commandLinkStyle"
                                action="#{consultarDptoMunpioAvaluo.cargarDeptosMunisAvaluo}"
                                update=":consultarDepartamentosMunicipioForm"
                                onstart="statusDialog2.show();"
                                oncomplete="statusDialog2.hide();
                                handleCompleteSIC(xhr, status, args, infoDeptosMunisWV, true);">
                                <f:setPropertyActionListener value="#{avaluo}"
                                                             target="#{consultarDptoMunpioAvaluo.avaluoSeleccionado}" />
                            </p:commandLink>
                            <h:outputText
                                rendered="#{!avaluo.tienePrediosEnDiferentesDeptos}"
                                value="#{avaluo.avaluoPredios[0].departamento.codigo} - #{avaluo.avaluoPredios[0].departamento.nombre}"
                                styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Municipio"
                                  sortBy="#{avaluo.avaluoPredios[0].municipio.nombre}">
                            <p:commandLink
                                value="#{avaluo.avaluoPredios[0].municipio.nombre}"
                                rendered="#{avaluo.tienePrediosEnDiferentesMunicipios}"
                                styleClass="commandLinkStyle"
                                action="#{consultarDptoMunpioAvaluo.cargarDeptosMunisAvaluo}"
                                update=":consultarDepartamentosMunicipioForm"
                                onstart="statusDialog2.show();"
                                oncomplete="statusDialog2.hide();
                                handleCompleteSIC(xhr, status, args, infoDeptosMunisWV, true);">
                                <f:setPropertyActionListener value="#{avaluo}"
                                                             target="#{consultarDptoMunpioAvaluo.avaluoSeleccionado}" />
                            </p:commandLink>
                            <h:outputText
                                rendered="#{!avaluo.tienePrediosEnDiferentesMunicipios}"
                                value="#{avaluo.avaluoPredios[0].municipio.codigo} - #{avaluo.avaluoPredios[0].municipio.nombre}"
                                styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Tipo avalúo" sortBy="#{avaluo.tipoAvaluo}">
                            <h:outputText id="AvaluoTipoAvaluoV-2"
                                          value="#{avaluo.tipoAvaluo}" styleClass="outputTextStyle">
                                <f:converter for="AvaluoTipoAvaluoV-2" converterId="converterCB" />
                            </h:outputText>
                        </p:column>

                        <p:column headerText="Solicitante"
                                  sortBy="#{avaluo.solicitante.nombreCompleto}">
                            <h:outputText value="#{avaluo.solicitante.nombreCompleto}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Nombre avaluador"
                                  sortBy="#{avaluo.avaluadores[0].nombreCompleto}">
                            <p:commandLink value="#{avaluo.avaluadores[0].nombreCompleto}"
                                           styleClass="commandLinkStyle"
                                           action="#{consultarAvaluadoresAsignados.cargarAvaluadoresAsignados}"
                                           update=":consultarAvaluadoresAsignadosPG"
                                           onstart="statusDialog2.show();"
                                           oncomplete="statusDialog2.hide();
                                           infoAvaluadoresAsignadosWV.show();"
                                           rendered="#{avaluo.tieneMultiplesAvaluadores}">
                                <f:setPropertyActionListener value="#{avaluo.secRadicado}"
                                                             target="#{consultarAvaluadoresAsignados.secRadicado}" />
                            </p:commandLink>
                            <h:outputText rendered="#{!avaluo.tieneMultiplesAvaluadores}"
                                          value="#{avaluo.avaluadores[0].nombreCompleto}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Fecha aprobación avalúo"
                                  sortBy="#{avaluo.fechaAprobacion}">
                            <h:outputText value="#{avaluo.fechaAprobacion}"
                                          styleClass="outputTextStyle">
                                <f:convertDateTime pattern="#{general.formatoFechaUsuario2}"
                                                   type="date" />
                            </h:outputText>
                        </p:column>

                        <p:column headerText="Número usuarios con permisos"
                                  sortBy="#{fn:length(avaluo.avaluoPermisosActivos)}">
                            <p:commandLink value="#{fn:length(avaluo.avaluoPermisosActivos)}"
                                           styleClass="commandLinkStyle" title="Desasignar permisos"
                                           action="#{asignarPermisosConsultaAvaluosReservados.cargarAsignarDesasignarPermisos}"
                                           update=":desasignarPermisosConsultaAvaluosReservadosDlgForm"
                                           onstart="statusDialog2.show();"
                                           oncomplete="statusDialog2.hide();
                                           handleCompleteSIC(xhr, status, args, desasignarPermisosWV, true);"
                                           rendered="#{not empty avaluo.avaluoPermisosActivos}">
                                <f:setPropertyActionListener value="#{avaluo}"
                                                             target="#{asignarPermisosConsultaAvaluosReservados.avaluoSeleccionado}" />
                            </p:commandLink>
                            <h:outputText value="#{fn:length(avaluo.avaluoPermisosActivos)}"
                                          styleClass="outputTextStyle"
                                          rendered="#{empty avaluo.avaluoPermisosActivos}" />
                        </p:column>

                    </p:dataTable>
                </h:panelGrid>
            </p:fieldset>

            <p:separator style="width:925px;height:3px" />
            <p:spacer height="7" width="0" />
            <p:outputPanel layout="block" style="text-align:right">
                <p:commandButton value="Cerrar"
                                 action="#{asignarPermisosConsultaAvaluosReservados.cerrar}"
                                 icon="ui-icon-circle-close" immediate="true" ajax="false" />
                <p:spacer height="0" width="30" />
            </p:outputPanel>
            <p:spacer height="20" width="0" />
        </h:form>

        <!-- ........... dialogs  .................. -->
        <p:dialog widgetVar="asignarPermisosWV" header="Asignar permisos"
                  appendToBody="true" closable="true" minimizable="false"
                  resizable="false" dynamic="true" modal="true" width="750">
            <ui:include
                src="/avaluos/administracion/asignarPermisosConsultaAvaluosReservadosDlg.xhtml" />
        </p:dialog>

        <p:dialog widgetVar="desasignarPermisosWV"
                  header="Desasignar permisos" appendToBody="true" closable="true"
                  minimizable="false" resizable="false" dynamic="true" modal="true"
                  width="750">
            <ui:include
                src="/avaluos/administracion/desasignarPermisosConsultaAvaluosReservadosDlg.xhtml" />
        </p:dialog>

        <misc:ultimateConfirmDialogCC id="confirmacionAsignacion"
                                      confirmMessage="OJO::: verificar primero atributos useStringActionOnNo='false' actionOnNoIsClose='true' que se adicionaron por ser obligatorios!!!!    ¿Está seguro de asignar permisos para consultar los avalúos reservados seleccionados a los profesionales de avalúos escogidos?"
                                      confirmUpdateOnYes=":asignarPermisosConsultaAvaluosReservadosDlgForm,
                                      :asignarPermisosConsultaAvaluosReservadosForm:avaluosReservadosFS"
                                      confirmDialogWV="asignarPermisosConfirmacionWV"
                                      voidActionOnYes="#{asignarPermisosConsultaAvaluosReservados.asignarPermisos}"
                                      additionalActionOnYes=";handleCompleteSIC(xhr, status, args, asignarPermisosWV, false);"
                                      useStringActionOnYes="false" 
                                      useStringActionOnNo="false" actionOnNoIsClose="true"
                                      width="600" />

        <misc:ultimateConfirmDialogCC id="confirmacionDesasignacion"
                                      confirmMessage="OJO::: verificar primero atributos useStringActionOnNo='false' actionOnNoIsClose='true' que se adicionaron por ser obligatorios!!!!    ¿Está seguro de desasignar permisos para consultar el avalúo reservado seleccionado a los profesionales de avalúos escogidos?"
                                      confirmUpdateOnYes=":desasignarPermisosConsultaAvaluosReservadosDlgForm,
                                      :asignarPermisosConsultaAvaluosReservadosForm:avaluosReservadosFS"
                                      confirmDialogWV="desasignarPermisosConfirmacionWV"
                                      voidActionOnYes="#{asignarPermisosConsultaAvaluosReservados.desasignarPermisos}"
                                      additionalActionOnYes=";handleCompleteSIC(xhr, status, args, desasignarPermisosWV, false);"
                                      useStringActionOnYes="false" actionOnNoIsClose="true" 
                                      useStringActionOnNo="false" width="600" />

        <!-- ........... dialogs otros casos de uso ................. -->
        <avaluos:informacionSolicitudCC id="isCC"
                                        thisWVName="infoSolicitudCCWV" thisId="isCC" mostrarInfoPago="false"
                                        detallePredioWVName="detallesPredioWV" detallePredioId="dpCC"
                                        infoPredialWVName="prediosWV" infoPredialId="pdsDialog"
                                        managedBean="#{consultaInformacionSolicitud}" />

        <p:dialog header="Adicionar solicitante" dynamic="true"
                  widgetVar="addSolicitanteDialogWV" width="900" appendToBody="true"
                  modal="true">
            <p:panel header="Datos del solicitante">
                <ui:include src="/avaluos/util/capturaDatosSolicitante.xhtml">
                    <ui:param name="adicionarSolicitanteWvParam"
                              value="guardarSolicitanteConfirmationWV" />
                </ui:include>
            </p:panel>
        </p:dialog>

        <p:dialog id="adminAnexos" widgetVar="administrarAnexosWV"
                  header="Anexos relacionados" appendToBody="true" closable="true"
                  minimizable="false" dynamic="true" width="900">
            <ui:include src="/avaluos/ingresoSolicitud/administrarAnexos.xhtml">
                <ui:param name="managedBeanParam"
                          value="#{administracionDocumentacionAvaluoComercial}" />
            </ui:include>
        </p:dialog>

        <p:dialog widgetVar="infoDeptosMunisWV"
                  header="Municipios y departamentos asociados al avalúo"
                  appendToBody="true" closable="true" minimizable="false"
                  resizable="false" dynamic="true" modal="true" width="600">
            <ui:include
                src="/avaluos/transversal/consultarDepartamentosMunicipiosAvaluo.xhtml" />
        </p:dialog>

        <p:dialog widgetVar="infoPredialWV"
                  header="Información de los predios asociados al avalúo"
                  appendToBody="true" closable="true" minimizable="false"
                  resizable="false" dynamic="true" modal="true" width="850">
            <ui:include
                src="/avaluos/transversal/consultarInformacionPredial.xhtml" />
        </p:dialog>

        <p:dialog widgetVar="infoAvaluadoresAsignadosWV"
                  header="Profesionales de avalúos" appendToBody="true" closable="true"
                  minimizable="false" resizable="false" dynamic="true" modal="true"
                  width="750">
            <ui:include
                src="/avaluos/asignacion/consultarAvaluadoresAsignados.xhtml" />
        </p:dialog>

        <predio:detallesPredioCC id="dpCC" thisWVName="detallesPredioWV"
                                 mostrarDatosTramites="false" thisIdPlusColon=":dpCC"
                                 mostrarFichaPredial="false" />

        <ui:include src="../../util/visorGeografico.xhtml" />

    </ui:define>
</ui:composition>